//+------------------------------------------------------------------+
//|                                                        kotov.mq4 |
//|                                                             Rosh |
//|                 http://forum.viac.ru/viewtopic.php?p=68234#68234 |
//+------------------------------------------------------------------+
#property copyright "Rosh"
#property link      "http://forum.viac.ru/viewtopic.php?p=68234#68234"
#include <Tracert.mqh>
#include <bAccount.mqh>
//---- input parameters
extern int       CloseHour=14;
extern int       Slippage=3;
extern double    SpreadK=2.0;
extern double    Lots=0.1;
extern int       PeriodType=0; //  ? -  4- ,   ? -  
extern double    StopLoss;
extern int       ExpertMagicNumber=3002;
extern double    Zazor=5; //    ?     
extern int       TrailingStop=10;
extern int       TrailingPeriodType=1;//  (  )  4- 
extern int       TrailingModeType=1;//    ( ),   / 
int PeriodBars;
int Spread, CurDay;
int myBars;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
  if (PeriodType==0) PeriodBars=PERIOD_H4; else PeriodBars=PERIOD_D1;
  if (TrailingPeriodType==0) TrailingPeriodType=PERIOD_H4; else TrailingPeriodType=0;//   - 
  Spread=MarketInfo(Symbol(),MODE_SPREAD);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
   {
   if (IsTesting())
      {
      WriteLastAccountInfo();
      }
   }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
int TotalExpert()
   {
   int total,totalExpert;
   total=OrdersTotal();
   totalExpert=0;
   if (OrdersTotal()>0)
      {
      for (int cnt=0;cnt<total;cnt++)
         {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if ((OrderMagicNumber()==ExpertMagicNumber)&&(Symbol()==OrderSymbol())) 
            {
            totalExpert++;
            }
         }
      }
   return(totalExpert);      
   }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool isNewBar()
   {
   bool res=false;
   if (myBars!=Bars)
      {
      myBars=Bars;
      res=true;
      }
   return(res);   
   }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void CloseAllOrders()
  {
   int typeTrade;
//---- 
   for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!=ExpertMagicNumber) continue;
      if (OrderSymbol()!=Symbol()) continue;
      typeTrade=OrderType();
      //Print("typeTrade=",typeTrade);
      switch (typeTrade)
         {
         case OP_BUY: {OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);Sleep(30000);break;}
         case OP_SELL:{OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Yellow);Sleep(30000);break;}
         default: break;
         }
      }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void TrailingAllTrades()
  {
   int typeTrade,cnt;
//---- 
   if (TrailingModeType==0)
      {
      //============================================================      
      for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
         {
         if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
            {
            if (OrderMagicNumber()!=ExpertMagicNumber) continue;
            if (OrderSymbol()!=Symbol()) continue;
            typeTrade=OrderType();
            //Print("Trailing typeTrade=",typeTrade);
            switch (typeTrade)
               {
               //case OP_BUY: 
               case OP_SELL: 
                  if (Ask-OrderOpenPrice()>TrailingStop*Point || Ask-OrderTakeProfit()>TrailingStop*Point)
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Ask-TrailingStop*Point,0,Yellow);
                  break;
               //case OP_SELL:
               case OP_BUY: 
                  if (OrderOpenPrice()-Bid>TrailingStop*Point || OrderTakeProfit()-Bid>TrailingStop*Point)
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Bid+TrailingStop*Point,0,Yellow);
                  break;
               default: break;
               }
            }
         }
      //============================================================
      }
      
   if (TrailingModeType!=0)
      {
      for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
         {
         if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
            {
            if (OrderMagicNumber()!=ExpertMagicNumber) continue;
            if (OrderSymbol()!=Symbol()) continue;
            typeTrade=OrderType();
            switch (typeTrade)
               {
               //case OP_BUY: 
               case OP_SELL:
                  if ((Ask-iLow(NULL,TrailingPeriodType,1)+Zazor*Point>TrailingStop*Point)||(iLow(NULL,TrailingPeriodType,1)-Zazor*Point-OrderTakeProfit()>Point))
                     Print("TrailingModeType=",TrailingModeType,"  Ask=",Ask," TrailingPeriodType=",TrailingPeriodType);
                     Print("OrderTakeProfit=",OrderTakeProfit());
                     Print("Ask-iLow(NULL,TrailingPeriodType,1)+Zazor*Point=",(Ask-iLow(NULL,TrailingPeriodType,1)+Zazor*Point)/Point);
                     Print("iLow(NULL,TrailingPeriodType,1)-Zazor*Point-OrderTakeProfit()=",(iLow(NULL,TrailingPeriodType,1)-Zazor*Point-OrderTakeProfit())/Point);

                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),iLow(NULL,TrailingPeriodType,1)-Zazor*Point,0,Yellow);
                  break;
               //case OP_SELL:
               case OP_BUY: 
                  if ((iHigh(NULL,TrailingPeriodType,1)+(Spread+Zazor)*Point-Bid>TrailingStop*Point)||
                     ((OrderTakeProfit()-iHigh(NULL,TrailingPeriodType,1)-(Spread+Zazor)*Point>Point)&&(OrderTakeProfit()!=0))||(OrderTakeProfit()==0))
                     Print("TrailingModeType=",TrailingModeType,"  Bid=",Bid," TrailingPeriodType=",TrailingPeriodType);
                     Print("OrderTakeProfit=",OrderTakeProfit());
                     Print("iHigh(NULL,TrailingPeriodType,1)+(Spread+Zazor)*Point-Bid=",(iHigh(NULL,TrailingPeriodType,1)+(Spread+Zazor)*Point-Bid)/Point);
                     Print("OrderTakeProfit()-iHigh(NULL,TrailingPeriodType,1)-(Spread+Zazor)*Point=",(OrderTakeProfit()-iHigh(NULL,TrailingPeriodType,1)-(Spread+Zazor)*Point)/Point);

                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),iHigh(NULL,TrailingPeriodType,1)+(Spread+Zazor)*Point,0,Yellow);
                  break;   
               default: break;
               }
            }      
         }

      }
      
            
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int total;
   if(!isNewBar()) return;
   if(IsTesting())
      {
      SetTrace();
      WriteAccountInfo();
      }
   total=TotalExpert();
//---- 
   //Print("CurTime()=",TimeHour(CurTime()));
   if (total==0 && TimeHour(CurTime())>=0 && TimeHour(CurTime())< CloseHour)
      {
      if ((Ask+Bid)/2.0>(iHigh(NULL,PeriodBars,1)+iLow(NULL,PeriodBars,1)+iOpen(NULL,PeriodBars,1)+iClose(NULL,PeriodBars,1))/4.0 && Bid>iOpen(NULL,PeriodBars,0))
         {
         if (  TimeDay( CurTime())!=CurDay   )
            {
            //OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+2*Spread*Point,Slippage,iLow(NULL,PeriodBars,1)-Zazor*Point,0,"buy",0,CurTime()+8*60*60,Blue);
            OrderSend(Symbol(),OP_SELLLIMIT,Lots,Ask+SpreadK*Spread*Point,Slippage,0,iLow(NULL,PeriodBars,1)-Zazor*Point,"selllimit",ExpertMagicNumber,CurTime()+8*60*60,Red);
            CurDay=TimeDay(CurTime());
            }
         }
      if ((Ask+Bid)/2.0<(iHigh(NULL,PeriodBars,1)+iLow(NULL,PeriodBars,1)+iOpen(NULL,PeriodBars,1)+iClose(NULL,PeriodBars,1))/4.0 && Bid<iOpen(NULL,PeriodBars,0)) 
         {
         if (  TimeDay( CurTime())!=CurDay   )
            {
            //OrderSend(Symbol(),OP_SELLSTOP,Lots,Bid-2*Spread*Point,Slippage,iHigh(NULL,PeriodBars,1)+(Ask-Bid)+Zazor*Point,0,"sell",0,CurTime()+8*60*60,Red);
            OrderSend(Symbol(),OP_BUYLIMIT,Lots,Bid-SpreadK*Spread*Point,Slippage,0,iHigh(NULL,PeriodBars,1)+(Ask-Bid)+Zazor*Point,"buylimit",ExpertMagicNumber,CurTime()+8*60*60,Blue);
            CurDay=TimeDay(CurTime());
            }
         }
      }
   if (total>0 && TimeHour(CurTime())>=CloseHour) CloseAllOrders();
      else
         {
         if (total>0 &&TrailingStop!=0)
            TrailingAllTrades();
         } 
//----
   return(0);
  }
//+------------------------------------------------------------------+